//---------------------------------------------------------------------------
// Copyright (c) 1991,1992 Southeastern Universities Research Association,
//                         Continuous Electron Beam Accelerator Facility
//
// This software was developed under a United States Government license
// described in the NOTICE file included as part of this distribution.
//----------------------------------------------------------------------------
//
// description: Data Type Definition
//
// Author: Jie Chen
//
//
//                                       
//--------------------------------------------------------------------------

#ifndef _RSVC_TYPES_H
#define _RSVC_TYPES_H

typedef unsigned char BYTE;

enum rsvcDataTypes 
	{
	RSVC_BYTE, 
	RSVC_INT16, 
	RSVC_UINT16,
	RSVC_INT32,
	RSVC_UINT32,
	RSVC_FLOAT, 
	RSVC_DOUBLE, 
	RSVC_STRING, 
	RSVC_TIMESTAMP,
	RSVC_INVALID
	};
 
// rsvc time struct 
typedef struct {
    unsigned long   secPastEpoch;    // seconds since Jan. 1, 1970
    unsigned long   nsec;            // nanoseconds within second 
} rsvc_TS_STAMP;

#define RSVC_TAG_MAX_LEN 16
#endif
