//-----------------------------------------------------------------------------
// Copyright (c) 1994,1995 Southeastern Universities Research Association,
//                         Continuous Electron Beam Accelerator Facility
//
// This software was developed under a United States Government license
// described in the NOTICE file included as part of this distribution.
//
//-----------------------------------------------------------------------------
//
// Description:
//      Utility functions for caService and caRequestObject
//
// Author:  Jie Chen
//
// Revision History:
//   caMisc.h,v
// Revision 1.1.1.1  1995/06/16  17:14:02  epics
// initial import of cdev
//
//
#ifndef _CDEV_CA_MISC_H
#define _CDEV_CA_MISC_H

#include <cdevData.h>

extern int dataMatch (cdevData& data, int type, int count);
// PURPOSE: check whether a cdevData 'data' matches data type 'type'
//          and number of elements 'count'
// REQUIRE: type must be one of the supported. count >= 1
// PROMISE: 0: matched, -1: no match

#endif

