//-----------------------------------------------------------------------------
// Copyright (c) 1994,1995 Southeastern Universities Research Association,
//                         Continuous Electron Beam Accelerator Facility
//
// This software was developed under a United States Government license
// described in the NOTICE file included as part of this distribution.
//
//-----------------------------------------------------------------------------
//
// Description:
//      Implementation of cdevGlobalTagTable
//
// Author:  Jie Chen
//
// Revision History:
//   cdevGlobalTagTable.cc,v
// Revision 1.2  1996/05/07  16:32:31  chen
// Add stdio to the file
//
// Revision 1.1  1995/10/03  19:53:51  chen
// single instance of cdevTagTable
//
//
#include <stdio.h>
#include <cdevSpec.h>
#include "cdevGlobalTagTable.h"

cdevTagTable* cdevGlobalTagTable::instance_ = 0;

cdevGlobalTagTable::cdevGlobalTagTable (void)
{
#ifdef _CDEV_DEBUG
  printf ("Create cdevGlobalTagTable Class Object\n");
#endif
  // empty
}

cdevGlobalTagTable::~cdevGlobalTagTable (void)
{
#ifdef _CDEV_DEBUG
  printf ("delete cdevGlobalTagTable Class Object\n");
#endif
  // empty
}

cdevTagTable*
cdevGlobalTagTable::tagTable (void)
{
  if (cdevGlobalTagTable::instance_ == 0)
    cdevGlobalTagTable::instance_ = new cdevTagTable ();
  return cdevGlobalTagTable::instance_;
}
